#ifndef DICTCLASS_H
#define DICTCLASS_H
#include <tuple>
#include <vector>
#include <algorithm>
#include <bits/stdc++.h>
#include <string> 
#include <cassert>
#include <map>
#include <list>
#include "util.h"
#include "histMatCell.h"
using namespace std;

class Dictionary{
private:
    vector<int> concepts;                        
    vector<bool> masks;
    vector<vector<double>> cost; 
    vector<vector<int>> usages;             //Usage vector
    vector<vector<int>> acceptedUsages;

    string logF;

    vector<string> dataSet;
    vector<double> mmlMatrix, condMatrix;

    double dictML = 0;
    int nSize = 0;
    int nSizeTrue = 0;
    double nullML = 0;
    int epsln;

    double tempML = 0;
    vector<double> tempCost;
    int tempCcpt = 0;

    //Flags
    bool pertLegend;        //perturbation legend in add,delete,update,replace
    bool seqCost;           //cost breakdown of each sequence
    bool alignPrint;
    bool printCostMat = true;

    double getAlignmentCost(const string&, const string&);
    int printAlignment(const string&, const string&, const vector<vector<HistMatCell>>&, const vector<vector<HistMatCell>>&, const vector<vector<HistMatCell>>&);
    string traceback(string, const HistMatCell*);

public:
    Dictionary(const vector<string>&, const int&, const vector<bool>&, vector<double>&, vector<double>&, const string&);
    void _pop();
    int _randConcept();
    void _newConcept(int&);
    void _suppressConcept(const int&);
    void _unsuppressConcept(const int&);
    bool _add(int&);
    void _remove(const int&);
    bool _swap(const int&);  
    void _undoSwap(const int&);
    void _getML(double&, double&); 
    int _size();
    void _acceptUsages();
    void _checkPoint(const string&);
    void _loadCheckPoint(const vector<string>&);
    void _printUsage(vector<string>&, const bool&, const bool&);   
};

#endif
